// $Id: contentanalysis.js,v 1.1 2010/04/18 23:51:09 tomdude48 Exp $

if (Drupal.jsEnabled) {
  $(document).ready(function () {
	if(Drupal.settings.contentanalysis.analyze_on_start == 1) {
//	  contentanalysis_analyze();	 
    }
  });
}


Drupal.behaviors.contentanalysisui = function () {
  $('div.analysis-results div.analyzer-analysis:eq(0)').show()
    $('.content-analysis-results:first').show()
    $('.analyzers h3.analyzer:first').addClass('active')
    $('h3.content-analysis-tab:first').addClass('active')
    $('div.analyzers h3.analyzer').mousedown(function () {
      $('h3.content-analysis-tab').removeClass('active')
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').children('.content-analysis-tab:first').addClass('active')
      $('div.analysis-results div.analyzer-analysis').hide()
      $('.analyzers h3.analyzer').removeClass('active')
      $(this).addClass('active')
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').show()
      $('.content-analysis-results').hide()
      $('div.analysis-results div.analyzer-analysis:eq(' + $('.analyzers h3.analyzer').index(this) + ')').children('.content-analysis-results:first').show()
    }) 
    $('h3.content-analysis-tab').mousedown(function () { 
      $('h3.content-analysis-tab').removeClass('active')
      $('.content-analysis-results').hide()
      $(this).addClass('active') 
      $(this).next().show()
    })
}

var contentanalysis_analyze = function() {
  // if TinyMCE is used, turn off and on to save body text to textarea

  var data = { 
    'nid': -1,
    'source': -1,
    'analyzers':-1,
    'title': -1, 
    'body': -1,
    'page_title':-1, 
    'meta_keywords':-1, 
    'meta_description':-1,
    'url': -1,
    'page': -1
  };
  if ($('#contentanalysis-page-analyzer-form').html()) {
    data.source = 'admin-form';
    data.body = $('[name=input]').val()

    data.nid = $('[name=input_nid]').val()
    data.url = $('[name=input_url]').val()
    if(data.body == '') {
      data.body = -1;
    }
    if(data.nid == '') {
      data.nid = -1;
    }
    if(data.url == '') {
      data.url = -1;
    }    
  } else if ($('#node-form').html()) {
    data.source = 'node-edit-form';
    if(typeof mceToggle == 'function') {
      mceToggle('edit-body', 'wysiwyg4body');
    }
    data.title = $('[name=title]').val()
    data.body = $('[name=body]').val()
    data.nid = Drupal.settings.contentanalysis.nid
    if($('[name=page_title]').length > 0) {
      data.page_title = $('[name=page_title]').val();
    }
    if(document.getElementById('edit-nodewords-keywords') != null) {
      data.meta_keywords = document.getElementById('edit-nodewords-keywords').value;
    }
    if(document.getElementById('edit-nodewords-description') != null) {
      data.meta_description = document.getElementById('edit-nodewords-description').value;
    }
    if(typeof mceToggle == 'function') {
      mceToggle('edit-body', 'wysiwyg4body');
    }	
  } else {
    data.source = 'page-link';
    data.page = $('html').html()  
    data.url = window.location.href
  }
  
  //alert('data.nid ' + data.nid)
  var a = new Array();
  var i = 0;
  $('#contentanalysis_analyzers .form-checkbox:checked').each ( function () {  
    var expr = new RegExp(/\[[^\]]+\]/);
    a[i] = expr.exec($(this).attr('name'))[0].replace(']', '').replace('[','');    
    i++;
  })
  data.analyzers = a.join(',');

  modules = Drupal.settings.contentanalysis.analyzer_modules;
  for(i=0;i<modules.length;i++) {
    if (eval('typeof ' + modules[i]['module'] + '_contentanalysis_data == "function"')) {
      d = eval(modules[i]['module']+'_contentanalysis_data()');
      for(var k in d) {
        eval('data.ao_'+modules[i]['aid']+'_'+k+' = "'+d[k]+'";');
      }
    }
  }

  $.ajax({
    type: 'POST',
    url: Drupal.settings.contentanalysis.analyze_callback,
    data: data,
    dataType: 'json',
    success: function(data, textStatus) {
      $('#analysis-modal').append(data.main['output'])
      $('#analysis-modal .progress').remove()
      Drupal.behaviors.contentanalysisui()
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert("error " + XMLHttpRequest.toString());
    },
  });
  return false;	
}
